Foreman - Feature #26651

Support component re-mounting on partials from AJAX
04/18/2019 01:25 PM - Ondrej Prazak

Status: Ready For Testing
Priority: Normal
Assignee: Ondrej Prazak
Category:
Target version:
Difficulty: Fixed in Releases:
Triaged: No Found in Releases:
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/6699
Description

We use mount_react_component helper that inserts script, which takes care of mounting React components. The problem is that
script tags do not evaluate when inserted into DOM as innerHTML. When AJAX calls to retrieve partial which is inserted into page,
the script does not run and react component is not mounted.

We should make sure that react components do not disappear when they are in a partial that is rendered via AJAX.

Related issues:

Related to Foreman - Feature #26735: Mount react components from web components Closed
Blocks Ansible - Bug #26645: Ansible roles switcher not mounted after form pa... Closed
History

#1 - 04/18/2019 01:32 PM - Ondfej Prazak

- Blocks Bug #26645: Ansible roles switcher not mounted after form partial re-render added

#2 - 04/18/2019 01:52 PM - The Foreman Bot
- Status changed from New to Ready For Testing
- Pull request https://github.com/theforeman/foreman/pull/6699 added

#3 - 04/18/2019 06:00 PM - Ondfej Ezr

This is not a default behaviour of ajax :thinking: by default it is running the scripts it is adding ($ajax.load), so | believe it is problem in just specific
corner cases, where we are setting the content wrong manualy.
Could you please share where we are hitting the problem?

#4 - 04/23/2019 06:08 AM - Ondfej Prazak

Ondfej Ezr wrote:

This is not a default behaviour of ajax :thinking: by default it is running the scripts it is adding ($ajax.load), so | believe it is problem in just specific
corner cases, where we are setting the content wrong manualy.
Could you please share where we are hitting the problem?

We use $.ajax and then insert the content: https:/github.com/theforeman/foreman/blob/develop/app/assets/javascripts/host_edit.js#L.314
This is causing problems for Ansible roles switcher, see https:/projects.theforeman.org/issues/26645 and
https://community.theforeman.org/t/unable-to-assigne-ansible-roles-to-host-hostgroups/13634/13

#5 - 04/26/2019 10:49 AM - Ondfej Ezr

Well, that is a bit different problem than you are describing and | am thinking if this is the right aproach...
| believe the problem lays in mounting component on elements which are not part of DOM just yet.
React tries to mount the funcionality on jQuery virtual DOM object, but looking for it in dom.

Do not find it, gives up and than the element is injected into dom by jquery.

So | believe running the script once more is not really nice solution, though as a workaround works.
https://github.com/theforeman/foreman/blob/develop/app/assets/javascripts/host_edit.js#L314
https://projects.theforeman.org/issues/26645
https://community.theforeman.org/t/unable-to-assigne-ansible-roles-to-host-hostgroups/13634/13

#6 - 05/02/2019 07:10 PM - Ondfej Ezr

- Related to Feature #26735: Mount react components from web components added
